require 'httparty'

module Superfeedee
  
  class Client
    include HTTParty
        
    def initialize options={}
      @auth = { :username => options[:user], :password => options[:pass] } unless options[:user].nil?
      self.class.headers options[:headers] unless options[:headers].nil?
      self.class.base_uri options[:hub] || 'https://superfeedr.com/hubbub'
    end
    
    def post(mode, options={})
      request_options = { :query => { 'hub.verify' => options[:verify_mode] || 'sync', 
                                      'hub.mode' => mode, 
                                      'hub.callback' => options[:callback_url], 
                                      'hub.topic' => options[:topic_url], 
                                      'hub.verify_token' => options[:verify_token] || '' } }
      
      request_options[:basic_auth] = @auth if @auth
      
      self.class.post('/', request_options)
    end
    
    def subscribe options
      post('subscribe', options)
    end
    
    def unsubscribe options
      post('unsubscribe', options)
    end
  end
  
  def self.generate_token
    rand(36**32).to_s 36
  end
  
end